/***************************************************
 * Iso sprite editor                               *
 ***************************************************
 *                                                 *
 * This editor uses Allegro  (DOS, Linux)          *
 * released by MXM Projects  http://mxm.ticalc.org *
 * programmed by MXM-TriX    mxmtrix@gmx.net       *
 *                                                 *
 * Last update               06/17/1999            *
 ***************************************************/


#include <stdio.h>
#include <stdlib.h>

/* Faster compiling */
#define	 alleg_joystick_unused
#define	 alleg_flic_unused
#define	 alleg_sound_unused
#define	 alleg_file_unused
#define	 alleg_datafile_unused
#define	 alleg_math_unused
#define	 alleg_gui_unused

#ifdef LINUX
#error IsoEdit currently not availabel for Linux!
#endif

#include <allegro.h>


typedef	struct {
    unsigned char bitmap[26][16];
    char     name[32];
} Sprite;

Sprite IsoSprites[100]; /* Should be enough */
int    CurrentSprite, NrOfSprites;

/* Draws the display (user interface) */
int drawmap ()
{
   int i;

   clear (screen);
   for (i = 0; i <= 26;	i++)
   {
       hline (screen, 20, 20+16*i, 20+16*16, 200);
   } /* for */
   for (i = 0; i <= 16;	i++)
   {
      vline (screen, 20+16*i, 20, 20+26*16, 200);
   } /* for */

   /* Little sprite display */
   rect	(screen, 40+16*16, 20, 40+16*16+16+1, 20+25+2, 200);

   /* Create ColorMap */
   for (i = 64;	i <= 68; i++)
   {
      RGB tempcolor;
      if (i != 68) {
	 tempcolor.r = (i-64)*8+96;
	 tempcolor.g = (i-64)*8+96;
	 tempcolor.b = (i-64)*8+96;
      }	else {
	 tempcolor.r = 0;
	 tempcolor.g = 255;
	 tempcolor.b = 255;
      }	/* if */
      set_color	(i, &tempcolor);
      rectfill (screen,	40+16*16+16*(i-64), 100, 40+16*16+16*(i-64)+16,	116, i);
   } /* for */

   textprintf (screen, font, 0,	0, 200,	"Isometric sprite editor by MXM Projects");
   textprintf (screen, font, 0,	8, 200,	"***************************************");

   textprintf (screen, font, 0,	440, 200, "<N>   Name of sprite  <A> Add a new sprite  <+/-> Show other sprite");
   textprintf (screen, font, 0,	450, 200, "<E/X> Exit            <S> Save              <L>   Load");
   textprintf (screen, font, 0, 460, 200, "<C>   Clear");

   return 0;
} /* drawmap */

int SetPixel (int x, int y, int	color)
{
   IsoSprites[CurrentSprite].bitmap[y][x] =	color;

   scare_mouse ();
   floodfill (screen, 21+16*x, 21+16*y,	color +	64);
   putpixel (screen, 41+16*16+x, 21+y, color + 64);
   unscare_mouse ();
   return 1;
} /* SetPixel */

/* Initialize a sprite */
int initialize_sprite ()
{
   /* This sprite offers the structure for the pseudo 3d sprite */
   Sprite PredefinedSprite ={{4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 4,
			      4, 4, 4, 3, 3, 3,	3, 3, 3, 3, 3, 3, 3, 3,	3, 3,
			      4, 4, 4, 3, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	4, 3,
			      4, 4, 3, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	3, 4,
			      4, 4, 3, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 4,	3, 4,
			      4, 3, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 3,	4, 4,
			      4, 3, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 4, 3,	4, 4,
			      3, 4, 4, 4, 4, 4,	4, 4, 4, 4, 4, 4, 3, 4,	4, 4,
			      3, 3, 3, 3, 3, 3,	3, 3, 3, 3, 3, 3, 3, 4,	4, 4},
			      {""}};

   memcpy (IsoSprites[CurrentSprite].bitmap, &PredefinedSprite, sizeof (Sprite));
   sprintf (IsoSprites[CurrentSprite].name,	"sprite_%d", CurrentSprite + 1);
   return 1;
} /* initialize_sprite */

/* Display actual sprite (whole redrawing) */
int draw_new_sprite ()
{
   int i, j;

   for (i = 0; i < 16; i++)
      for (j = 0; j < 26; j++)
	 SetPixel (i, j, IsoSprites[CurrentSprite].bitmap[j][i]);

   return 0;
} /* draw_new_sprite */

int LoadFiles ()
{
   FILE	*infile;

   #ifdef DJGPP
    infile = fopen ("sc_spr.mxm", "rb");
   #else
    /* Linux support */
    infile = fopen ("Iso-sprites.MXM", "rb");
   #endif
   if (infile == NULL) return 0;
   NrOfSprites = 0;
   while (1)
   {
      if (feof (infile)) break;
      fread (&IsoSprites[NrOfSprites], sizeof (Sprite), 1, infile);
      NrOfSprites++;
   } /* while */
   NrOfSprites--;
   CurrentSprite = 0;

   scare_mouse ();
   drawmap ();
   draw_new_sprite ();
   unscare_mouse ();

   fclose (infile);
   return 1;
} /* LoadFiles */

/* Save all sprites */
int SaveFiles ()
{
   FILE	*outfile;
   int	i, sum,	j, k, l;

   #ifdef DJGPP
    outfile = fopen ("sc_spr.mxm", "wb");
   #else
    /* When allegro is availabel for Linux! */
    outfile = fopen ("Iso-sprites.MXM", "wb");
   #endif
   if (outfile == NULL)	return 0;
   fwrite (IsoSprites, sizeof (Sprite), NrOfSprites, outfile);
   fclose (outfile);

   outfile = fopen ("sprites.h", "w");
   if (outfile == NULL)	return 0;
   fprintf (outfile, "\n"
		     ";*************************************\n"
		     "; MXM Projects Isometric sprite editor\n"
		     ";*************************************\n\n"
                     "; Sprite table, because you probably have a different size from sprite to sprite\n\n"
		     "sprite_table   dc.l\t");
   /* Save all sprites */
   for (i = 0; i < NrOfSprites;	i++)
   {
      fputs (IsoSprites[i].name, outfile);
      if (i < NrOfSprites - 1)
	 fprintf (outfile, ",\n\t\t\t\t");
   } /* for */
   fprintf (outfile, "\n\n; Sprites (reverse order)\n\n");
   for (i = 0; i < NrOfSprites;	i++)
   {
      if (IsoSprites[i].name[0] == '\0') continue;
      /* First of all, we have to find the start of the sprite */
      for (j = 0; j < 26; j++)
      {
	 sum = 0;
	 for (k	= 0; k < 16; k++)
	    sum	+= (IsoSprites[i].bitmap[j][k] % 5);
	 if (sum != 0) break;
      }	/* for */
      /* The following condition shouldn't happen */
      if (j == 26) break;
      fprintf (outfile,	"\n\n%-20s\t dc.w %d,\n", IsoSprites[i].name, 26 - j);
      for (k = 25; k >=	j; k--)
      {
	 fprintf (outfile, "\t\t\t\tdc.w %%");
	 /* Build mask */
	 for (l	= 0; l < 16; l++)
	    fputc (!(IsoSprites[i].bitmap[k][l] & 3) + '0',	outfile);
	 fprintf (outfile, ",\n\t\t\t\tdc.w %%");
	 for (l	= 0; l < 16; l++)
	    fputc ((IsoSprites[i].bitmap[k][l] & 1)	+ '0', outfile);
	 fprintf (outfile, ",\n\t\t\t\tdc.w %%");
	 for (l	= 0; l < 16; l++)
	    fputc (((IsoSprites[i].bitmap[k][l] & 2)>>1) + '0', outfile);
	 if (k != j)
	    fprintf (outfile, ",\n");
      }	/* for */
   } /* for */
   fclose (outfile);
   return 1;
} /* SaveFiles */

/* Iso sprite editor */
int editor ()
{
   int CurrentColor = 4, Key, i, nKey;

   show_mouse (screen);
   initialize_sprite ();
   draw_new_sprite ();

   while (1) {
     scare_mouse ();
     textprintf	(screen, font, 0, 470, 200, "Sprite %d/%d (%s) Color %d",
		 CurrentSprite + 1, NrOfSprites,
		 IsoSprites[CurrentSprite].name, CurrentColor);
     unscare_mouse ();
     while (!mouse_b &&	!keypressed ());
     if	(keypressed ())
     {
	Key = readkey ();
	switch (Key & 0xff)
	{
           case 'c':
           case 'C': initialize_sprite ();
                     draw_new_sprite ();
                     break;
	   case	's':
	   case	'S': SaveFiles ();
		     break;
	   case	'l':
	   case	'L': LoadFiles ();
		     break;
	   case	'X':
	   case	'x':
	   case	'E':
	   case	'e': return 1;
	   case	'a':
	   case	'A': /* New sprite */
		     CurrentSprite++;
		     if	(CurrentSprite == NrOfSprites) NrOfSprites++;
                     initialize_sprite ();
		     draw_new_sprite ();
		     break;
	   case	'+': if	(CurrentSprite == NrOfSprites - 1)
			CurrentSprite =	0;
		     else
			CurrentSprite++;
		     draw_new_sprite ();
		     break;
	   case	'-': if	(CurrentSprite == 0)
			CurrentSprite =	NrOfSprites - 1;
		     else
			CurrentSprite--;
		     draw_new_sprite ();
		     break;
	   case	'n':
	   case	'N': /* get the sprite name */
		     textprintf	(screen, font, 500, 470, 200, "Name?");
		     for (i = 0; i < 25; i++)
		     {
			nKey = readkey ();
			if ((nKey & 0xff) == 0x13) break;
			IsoSprites[CurrentSprite].name[i] =	(nKey &	0xff);
		     } /* for */
		     IsoSprites[CurrentSprite].name[i] = '\0';
		     textprintf	(screen, font, 500, 470, 200, "       ");
		     break;
	   default:  break;
	} /* switch */
     } /* if keypressed */

     if	(mouse_b == 1 && mouse_x > 20 && mouse_y > 20 && mouse_x < 276 &&
	 mouse_y < 436)
     {
	SetPixel ((mouse_x - 20) / 16, (mouse_y	- 20) / 16, CurrentColor);
     } else if (mouse_b == 2 && mouse_x > 20 && mouse_y > 20 && mouse_x < 276 &&
       	        mouse_y < 436)
     {
        SetPixel ((mouse_x - 20) / 16, (mouse_y - 20) / 16, 4);
     } /* if */

     if	(mouse_b == 1 && mouse_x >= 296	&& mouse_y >= 100 &&
	 mouse_x <= 375	&& mouse_y <= 116)
     {
	show_mouse (NULL);
	CurrentColor = getpixel	(screen, mouse_x, mouse_y) - 64;
	show_mouse (screen);
     } /* if */

   } /* while */
   return 0;
} /* editor */

/* Main routine */
int main (void)
{
   RGB background = {255, 255, 255};

   printf ("Starting Iso sprite editor ...");

   /* Allegro initialization */
   allegro_init();
   install_keyboard();
   install_mouse();
   install_timer();

   /* GFX mode: 640x480 (8bit) */
   set_gfx_mode	(GFX_AUTODETECT, 640, 480, 0, 0);
   set_color (0, &background);

   memset (IsoSprites, 0, sizeof (IsoSprites));
   CurrentSprite = 0;
   NrOfSprites = 1;
   drawmap ();

   /* Edit routine */
   editor ();

   /* Allegro exit automatically done */
   return 0;
} /* main */
